PingAuthorize API Reference

Create Trust Framework Test Service Definition

POST {{apiPath}}/trust-framework/test/service/{{serviceId}}

The POST /trust-framework/test/service/{{serviceId}} operation creates a new test service definition.

Request Model

For property descriptions, refer to Authorization attributes (definition) data model

Property Type? Required?

decisionRequest

decisionRequest

attributeValueOverrides

Map<String, String>

serviceValueOverrides

Map<String, String>

Headers

Content-Type      application/json

x-user-id      {{userId}}

Body

raw ( application/json )

{
  "decisionRequest": {
    "domain": "a domain",
    "service": "",
    "identityProvider": "",
    "action": "",
    "attributes": {
      "amount": "165"
    }
  },
  "attributeValueOverrides": {

  },
  "serviceValueOverrides": {
    "External PIP Service": "{ \"some-data\": \"some-value\" }"
  }
}

Example Request

  • cURL

  • C#

  • Go

  • HTTP

  • Java

  • jQuery

  • NodeJS

  • Python

  • PHP

  • Ruby

  • Swift

curl --location --globoff '{{apiPath}}/trust-framework/test/service/{{serviceId}}' \
--header 'x-user-id: {{userId}}' \
--header 'Content-Type: application/json' \
--data '{
  "decisionRequest": {
    "domain": "a domain",
    "service": "",
    "identityProvider": "",
    "action": "",
    "attributes": {
      "amount": "165"
    }
  },
  "attributeValueOverrides": {

  },
  "serviceValueOverrides": {
    "External PIP Service": "{ \"some-data\": \"some-value\" }"
  }
}'
var options = new RestClientOptions("{{apiPath}}/trust-framework/test/service/{{serviceId}}")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("x-user-id", "{{userId}}");
request.AddHeader("Content-Type", "application/json");
var body = @"{" + "\n" +
@"  ""decisionRequest"": {" + "\n" +
@"    ""domain"": ""a domain""," + "\n" +
@"    ""service"": """"," + "\n" +
@"    ""identityProvider"": """"," + "\n" +
@"    ""action"": """"," + "\n" +
@"    ""attributes"": {" + "\n" +
@"      ""amount"": ""165""" + "\n" +
@"    }" + "\n" +
@"  }," + "\n" +
@"  ""attributeValueOverrides"": {" + "\n" +
@"    " + "\n" +
@"  }," + "\n" +
@"  ""serviceValueOverrides"": {" + "\n" +
@"    ""External PIP Service"": ""{ \""some-data\"": \""some-value\"" }""" + "\n" +
@"  }" + "\n" +
@"}" + "\n" +
@"";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/trust-framework/test/service/{{serviceId}}"
  method := "POST"

  payload := strings.NewReader(`{
  "decisionRequest": {
    "domain": "a domain",
    "service": "",
    "identityProvider": "",
    "action": "",
    "attributes": {
      "amount": "165"
    }
  },
  "attributeValueOverrides": {

  },
  "serviceValueOverrides": {
    "External PIP Service": "{ \"some-data\": \"some-value\" }"
  }
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("x-user-id", "{{userId}}")
  req.Header.Add("Content-Type", "application/json")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
POST /trust-framework/test/service/{{serviceId}} HTTP/1.1
Host: {{apiPath}}
x-user-id: {{userId}}
Content-Type: application/json

{
  "decisionRequest": {
    "domain": "a domain",
    "service": "",
    "identityProvider": "",
    "action": "",
    "attributes": {
      "amount": "165"
    }
  },
  "attributeValueOverrides": {

  },
  "serviceValueOverrides": {
    "External PIP Service": "{ \"some-data\": \"some-value\" }"
  }
}
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n  \"decisionRequest\": {\n    \"domain\": \"a domain\",\n    \"service\": \"\",\n    \"identityProvider\": \"\",\n    \"action\": \"\",\n    \"attributes\": {\n      \"amount\": \"165\"\n    }\n  },\n  \"attributeValueOverrides\": {\n    \n  },\n  \"serviceValueOverrides\": {\n    \"External PIP Service\": \"{ \\\"some-data\\\": \\\"some-value\\\" }\"\n  }\n}\n");
Request request = new Request.Builder()
  .url("{{apiPath}}/trust-framework/test/service/{{serviceId}}")
  .method("POST", body)
  .addHeader("x-user-id", "{{userId}}")
  .addHeader("Content-Type", "application/json")
  .build();
Response response = client.newCall(request).execute();
var settings = {
  "url": "{{apiPath}}/trust-framework/test/service/{{serviceId}}",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "x-user-id": "{{userId}}",
    "Content-Type": "application/json"
  },
  "data": JSON.stringify({
    "decisionRequest": {
      "domain": "a domain",
      "service": "",
      "identityProvider": "",
      "action": "",
      "attributes": {
        "amount": "165"
      }
    },
    "attributeValueOverrides": {},
    "serviceValueOverrides": {
      "External PIP Service": "{ \"some-data\": \"some-value\" }"
    }
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/trust-framework/test/service/{{serviceId}}',
  'headers': {
    'x-user-id': '{{userId}}',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({
    "decisionRequest": {
      "domain": "a domain",
      "service": "",
      "identityProvider": "",
      "action": "",
      "attributes": {
        "amount": "165"
      }
    },
    "attributeValueOverrides": {},
    "serviceValueOverrides": {
      "External PIP Service": "{ \"some-data\": \"some-value\" }"
    }
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
import requests
import json

url = "{{apiPath}}/trust-framework/test/service/{{serviceId}}"

payload = json.dumps({
  "decisionRequest": {
    "domain": "a domain",
    "service": "",
    "identityProvider": "",
    "action": "",
    "attributes": {
      "amount": "165"
    }
  },
  "attributeValueOverrides": {},
  "serviceValueOverrides": {
    "External PIP Service": "{ \"some-data\": \"some-value\" }"
  }
})
headers = {
  'x-user-id': '{{userId}}',
  'Content-Type': 'application/json'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/trust-framework/test/service/{{serviceId}}');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'x-user-id' => '{{userId}}',
  'Content-Type' => 'application/json'
));
$request->setBody('{\n  "decisionRequest": {\n    "domain": "a domain",\n    "service": "",\n    "identityProvider": "",\n    "action": "",\n    "attributes": {\n      "amount": "165"\n    }\n  },\n  "attributeValueOverrides": {\n    \n  },\n  "serviceValueOverrides": {\n    "External PIP Service": "{ \\"some-data\\": \\"some-value\\" }"\n  }\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/trust-framework/test/service/{{serviceId}}")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["x-user-id"] = "{{userId}}"
request["Content-Type"] = "application/json"
request.body = JSON.dump({
  "decisionRequest": {
    "domain": "a domain",
    "service": "",
    "identityProvider": "",
    "action": "",
    "attributes": {
      "amount": "165"
    }
  },
  "attributeValueOverrides": {},
  "serviceValueOverrides": {
    "External PIP Service": "{ \"some-data\": \"some-value\" }"
  }
})

response = http.request(request)
puts response.read_body
let parameters = "{\n  \"decisionRequest\": {\n    \"domain\": \"a domain\",\n    \"service\": \"\",\n    \"identityProvider\": \"\",\n    \"action\": \"\",\n    \"attributes\": {\n      \"amount\": \"165\"\n    }\n  },\n  \"attributeValueOverrides\": {\n    \n  },\n  \"serviceValueOverrides\": {\n    \"External PIP Service\": \"{ \\\"some-data\\\": \\\"some-value\\\" }\"\n  }\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/trust-framework/test/service/{{serviceId}}")!,timeoutInterval: Double.infinity)
request.addValue("{{userId}}", forHTTPHeaderField: "x-user-id")
request.addValue("application/json", forHTTPHeaderField: "Content-Type")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()

Example Response

201 Created

{
  "elapsedTime": 200300,
  "request": {
    "decisionRequest": {
      "domain": "",
      "service": "",
      "identityProvider": "",
      "action": "",
      "attributes": {

      }
    },
    "attributeValueOverrides": {

    },
    "serviceValueOverrides": {

    }
  },
  "authorized": false,
  "statements": [

  ],
  "status": {
    "code": "OKAY",
    "messages": [

    ],
    "errors": [

    ]
  },
  "attributes": {

  },
  "services": {
    "External PIP Service": {
      "id": "e3253224-e0cf-455e-9f11-e87a2b794dcb",
      "name": "External PIP Service",
      "settings": {
        "class": "rest",
        "urlFormat": {
          "@class": "FixedTemplate",
          "x": "http://www.google.com"
        },
        "body": {
          "@class": "FixedTemplate",
          "x": ""
        },
        "verb": "GET",
        "contentType": "application/json",
        "headers": [

        ],
        "authenticationType": "NONE",
        "authenticationAttributes": {
          "@class": "FixedTemplate",
          "x": {

          }
        },
        "tlsSettings": {
          "@class": "TlsSettings",
          "tlsValidationType": "DEFAULT",
          "tlsTruststore": null,
          "mtlsValidation": false,
          "mtlsKeystore": null
        },
        "cacheSettings": null
      },
      "consumedBy": [

      ],
      "invocations": [
        {
          "successful": true,
          "timestamp": "2025-03-19T15:45:30.944766Z",
          "elapsedTime": 174956,
          "response": "<!doctype html> some response here"
        }
      ],
      "valueProcessing": [
        {
          "processor": "TypeConversion",
          "expression": "STRING",
          "result": {
            "value": "<!doctype html> some response here",
            "type": "STRING"
          }
        }
      ],
      "elapsedTime": 189208
    }
  },
  "result": {
    "value": "<!doctype html> some response here",
    "type": "STRING"
  }
}